<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>KSPSetConvergenceTest</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="KSPSetConvergenceTest"><H1>KSPSetConvergenceTest</H1></A>
Sets the function to be used to determine convergence.   
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscksp.h" 
PetscErrorCode PETSCKSP_DLLEXPORT KSPSetConvergenceTest(KSP ksp,PetscErrorCode (*converge)(KSP,PetscInt,PetscReal,KSPConvergedReason*,void*),void *cctx)
</PRE>
Collective on <A HREF="../KSP/KSP.html#KSP">KSP</A>
<P>
<H3><FONT COLOR="#CC3333">Input Parameters</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>ksp </B></TD><TD>- iterative context obtained from <A HREF="../KSP/KSPCreate.html#KSPCreate">KSPCreate</A>()
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>converge </B></TD><TD>- pointer to int function
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>cctx    </B></TD><TD>- context for private data for the convergence routine (may be null)
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Calling sequence of converge</FONT></H3>
<pre>
    converge (<A HREF="../KSP/KSP.html#KSP">KSP</A> ksp, int it, <A HREF="../Sys/PetscReal.html#PetscReal">PetscReal</A> rnorm, <A HREF="../KSP/KSPConvergedReason.html#KSPConvergedReason">KSPConvergedReason</A> *reason,void *mctx)
</pre>
<P>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>ksp </B></TD><TD>- iterative context obtained from <A HREF="../KSP/KSPCreate.html#KSPCreate">KSPCreate</A>()
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>it </B></TD><TD>- iteration number
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>rnorm </B></TD><TD>- (estimated) 2-norm of (preconditioned) residual
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>reason </B></TD><TD>- the reason why it has converged or diverged
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>cctx  </B></TD><TD>- optional convergence context, as set by <A HREF="../KSP/KSPSetConvergenceTest.html#KSPSetConvergenceTest">KSPSetConvergenceTest</A>()
</TD></TR></TABLE>
<P>
<P>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
Must be called after the <A HREF="../KSP/KSP.html#KSP">KSP</A> type has been set so put this after
a call to <A HREF="../KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(), or <A HREF="../KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>().
<P>
The default convergence test, <A HREF="../KSP/KSPDefaultConverged.html#KSPDefaultConverged">KSPDefaultConverged</A>(), aborts if the
residual grows to more than 10000 times the initial residual.
<P>
The default is a combination of relative and absolute tolerances.
The residual value that is tested may be an approximation; routines
that need exact values should compute them.
<P>
In the default PETSc convergence test, the precise values of reason
are macros such as <A HREF="../KSP/KSP_CONVERGED_RTOL.html#KSP_CONVERGED_RTOL">KSP_CONVERGED_RTOL</A>, which are defined in petscksp.h.
<P>

<P>
<H3><FONT COLOR="#CC3333">Keywords</FONT></H3>
 <A HREF="../KSP/KSP.html#KSP">KSP</A>, set, convergence, test, context
<BR>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../KSP/KSPDefaultConverged.html#KSPDefaultConverged">KSPDefaultConverged</A>(), <A HREF="../KSP/KSPGetConvergenceContext.html#KSPGetConvergenceContext">KSPGetConvergenceContext</A>()
<BR><P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>advanced
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/ksp/ksp/interface/itfunc.c.html#KSPSetConvergenceTest">src/ksp/ksp/interface/itfunc.c</A>
<BR><A HREF="./index.html">Index of all KSP routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
<P><H3><FONT COLOR="#CC3333">Examples</FONT></H3>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex2f.F.html">src/ksp/ksp/examples/tutorials/ex2f.F.html</A><BR>
</BODY></HTML>
